<?php
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}
use \WHMCS\Database\Capsule as Capsule;
function blacklist_config()
{
    return array(
        'name' => '黑名单插件', 
        'description' => '用户注册黑名单', 
        'author' => 'Flyqie',
        'version' => '2.0',
        'fields' => array(
            'connectaddress' => array(
                'FriendlyName' => '管理员联系地址',
                'Type' => 'text',
                'Size' => '500',
                'Default' => '管理员联系地址',
                'Description' => '管理员联系地址',
            )
        )
    );
}
function blacklist_activate()
{
    $query = "CREATE TABLE IF NOT EXISTS `mod_blacklist` ( `id` int(255) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '主键', `type` varchar(500) NOT NULL COMMENT '黑名单类型', `typeb` varchar(500) NOT NULL COMMENT '黑名单类型B', `value` varchar(500) NOT NULL COMMENT '黑名单值', `addtime` datetime NOT NULL COMMENT '添加时间', `stoptime` varchar(500) NOT NULL COMMENT '截止时间', `reason` varchar(500) NOT NULL COMMENT '封禁原因(用户可见)', `remark` varchar(500) NOT NULL COMMENT '封禁备注(管理员可见)', `status` varchar(500) NOT NULL COMMENT '状态', PRIMARY KEY (`id`) ) ENGINE = MyISAM CHARSET = utf8 AUTO_INCREMENT = 0 COMMENT 'blacklist插件表';";
    full_query($query);
    return array('status' => 'success','description' => '插件已经成功激活,请设置插件');
}
function blacklist_deactivate()
{
    return array('status' => 'success','description' => '插件禁用成功,数据表未删除');
}
function blacklist_output($vars)
{
	if($_REQUEST['action'] == 'delete_info'){
		if(@$_REQUEST['ajax'] != 'true'){
			exit('禁止直接访问');
		}
		if(!@$_REQUEST['infosid']){
	    	$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$InfoFind = Capsule::table('mod_blacklist')->where('id',$_REQUEST['infosid'])->first();
		if(empty($InfoFind)){
	    	$Infoarray['result'] = 'error';
			$Infoarray['error'] = '无法在数据库中找到该记录';
		}else{
			$InfoRm = Capsule::table('mod_blacklist')->where('id',$_REQUEST['infosid'])->delete();
			if(!$InfoRm){
	    		$Infoarray['result'] = 'error';
				$Infoarray['error'] = '未知错误';
		    }else{
	    		$Infoarray['result'] = 'success';
			}
		}
		header('Content-Type: text/json; charset=utf-8');
		exit(json_encode($Infoarray));
	}elseif($_REQUEST['action'] == 'get_info_list'){
		if(@$_REQUEST['ajax'] != 'true'){
			exit('禁止直接访问');
		}
		$infolist = Capsule::table('mod_blacklist')->get();
		$infolistarray = array();
		$num = 0;
		foreach ($infolist as $values) {
			$infolistarray[$num]['id'] = $values->id;
			if($values->type == 'ip'){
				$infolistarray[$num]['type'] = 'IP';
			}elseif($values->type == 'email'){
				$infolistarray[$num]['type'] = '邮箱';
			}elseif($values->type == 'phone'){
				$infolistarray[$num]['type'] = '电话';
			}else{
				$infolistarray[$num]['status'] = '未知';
			}
			$infolistarray[$num]['value'] = $values->value;
			$infolistarray[$num]['addtime'] = $values->addtime;
        	if($values->stoptime == 'permanent'){
				$infolistarray[$num]['stoptime'] = '永久';
			}else{
				$infolistarray[$num]['stoptime'] = $values->stoptime;
			}
        	if($values->typeb == 'ticket'){
				$infolistarray[$num]['typeb'] = '工单';
        	}elseif($values->typeb == 'cart'){
				$infolistarray[$num]['typeb'] = '购买';
			}else{
				$infolistarray[$num]['typeb'] = '注册';
			}
			$infolistarray[$num]['reason'] = $values->reason;
			$infolistarray[$num]['remark'] = $values->remark;
			if($values->status == 'ok'){
				$infolistarray[$num]['status'] = '正常';
			}else{
				$infolistarray[$num]['status'] = '未知';
			}
			$infolistarray[$num]['action'] = '<td><a class="btn btn-danger btn-xs" href="javascript:void(0)" onclick="delete_info('.$values->id.')">删除记录</a></td>';
			$num++;
		}
		$Infoarray['result'] = 'success';
		$Infoarray['info'] = $infolistarray;
		header('Content-Type: text/json; charset=utf-8');
		exit(json_encode($Infoarray));
	}elseif($_REQUEST['action'] == 'add_info'){
		if(@$_REQUEST['ajax'] != 'true'){
			exit('禁止直接访问');
		}
		if(!@$_REQUEST['type'] || !@$_REQUEST['value'] || !@$_REQUEST['reason'] || !@$_REQUEST['remark'] || !@$_REQUEST['typeb']){
	    	$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		if(!empty($_REQUEST['stopday'])){
			$StopDay = $_REQUEST['stopday'];
		}else{
			$StopDay = '0';
		}
        if(trim($StopDay) != '0'){
			$stoptime = date('Y-m-d',strtotime(date('Y-m-d').'+'.trim($StopDay).'day'));
		}else{
			$stoptime = 'permanent';
		}
		$InfoAdd = Capsule::table('mod_blacklist')->insert(array('type' => $_REQUEST['type'],'status' => 'ok','value' => $_REQUEST['value'],'typeb' => $_REQUEST['typeb'],'stoptime' => $stoptime,'reason' => $_REQUEST['reason'],'remark' => $_REQUEST['remark'],'addtime' => date("Y-m-d H:i:s")));
		if(!$InfoAdd){
			$Infoarray['result'] = 'error';
			$Infoarray['error'] = '无法插入数据库';
			exit(json_encode($Infoarray));
		}
		$Infoarray['result'] = 'success';
		exit(json_encode($Infoarray));
	}elseif($_REQUEST['action'] == 'insert_info'){
		if(@$_REQUEST['ajax'] != 'true'){
			exit('禁止直接访问');
		}
		if(!@$_REQUEST['listinfos']){
	    	$Infoarray['result'] = 'error';
			$Infoarray['error'] = '参数不全';
			exit(json_encode($Infoarray));
		}
		$text = nl2br($_REQUEST['listinfos']);
        $textArr = explode("<br />",$text);
		$num = 0;
        foreach($textArr as $val){
			$Expblacklist = explode("[BLACKLIST]",$val);
			if(!$Expblacklist[0] || !$Expblacklist[1] || !$Expblacklist[2] || !$Expblacklist[3] || !$Expblacklist[4] || !$Expblacklist[5] || !$Expblacklist[6]){
	    	     $Infoarray['result'] = 'error';
			     $Infoarray['error'] = $num.'行格式错误,停止导入任务.';
			     exit(json_encode($Infoarray));
			}
			if($Expblacklist[7]){
			    $TypebIn = $Expblacklist[7];
			}else{
				$TypebIn = 'reg';
			}
			$InfoFind = Capsule::table('mod_blacklist')->where('type',trim($Expblacklist[0]))->where('typeb',$TypebIn)->where('value',trim($Expblacklist[1]))->first();
			if($InfoFind){
				continue;
			}
	        $InfoAdd = Capsule::table('mod_blacklist')->insert(array('type' => trim($Expblacklist[0]),'value' => trim($Expblacklist[1]),'addtime' => $Expblacklist[2],'stoptime' => $Expblacklist[3],'reason' => $Expblacklist[4],'remark' => $Expblacklist[5],'status' => trim($Expblacklist[6]),'typeb' => trim($TypebIn)));
			if(!$InfoAdd){
				$Infoarray['result'] = 'error';
				$Infoarray['error'] = $num.'行无法插入数据库,停止导入任务.';
				exit(json_encode($Infoarray));
			}
			$num++;
        }
		$Infoarray['result'] = 'success';
		exit(json_encode($Infoarray));
	}elseif($_REQUEST['action'] == 'export_info'){
		$infolist = Capsule::table('mod_blacklist')->get();
		$InfoTxt = '';
		foreach ($infolist as $values) {
			$InfoTxt .= $values->type.'[BLACKLIST]'.$values->value.'[BLACKLIST]'.$values->addtime.'[BLACKLIST]'.$values->stoptime.'[BLACKLIST]'.$values->reason.'[BLACKLIST]'.$values->remark.'[BLACKLIST]'.$values->status.'[BLACKLIST]'.$values->typeb.PHP_EOL;
		}
        header ('Content-Description: File Transfer');
        header ('Content-Type: application/octet-stream');
        header ('Content-Disposition: attachment; filename=blacklist.txt');
		echo $InfoTxt;
		exit();
	}else{
		include 'templates.admin.php';
		if(@$_REQUEST['ajax'] != 'true'){
			echo $Header.PHP_EOL.$info_management.PHP_EOL.$Footer.PHP_EOL;
		}else{
			exit($info_management.PHP_EOL);
		}
	}
}
function blacklist_clientarea($vars)
{
	if(@$_REQUEST['deluseremail']){
		$InfoFind = \WHMCS\Database\Capsule::table('mod_blacklist')->where('type','email')->where('value',$_REQUEST['deluseremail'])->first();
		if(!$InfoFind){
			exit('无法在数据库中找到相应记录');
		}
		if($InfoFind->stoptime == 'permanent'){
			$Stoptime = '永久';
		}else{
			$Stoptime = $InfoFind->stoptime;
		}
        if($_REQUEST['typeb'] == 'ticket'){
			$Typeb = '工单';
        }elseif($_REQUEST['typeb'] == 'cart'){
			$Typeb = '购买';
		}else{
			$Typeb = '注册';
		}
		return array('pagetitle' => '黑名单','requirelogin' => false,'templatefile' => 'templates/fail', 'vars' => array('stoptime' => $Stoptime,'type' => '邮箱','value' => $InfoFind->value,'reason' => $InfoFind->reason,'connectaddress' => $vars['connectaddress'],'typeb' => $Typeb));
	}
	if(@$_REQUEST['deluserphone']){
		$InfoFind = \WHMCS\Database\Capsule::table('mod_blacklist')->where('type','phone')->where('value',$_REQUEST['deluserphone'])->first();
		if(!$InfoFind){
			exit('无法在数据库中找到相应记录');
		}
		if($InfoFind->stoptime == 'permanent'){
			$Stoptime = '永久';
		}else{
			$Stoptime = $InfoFind->stoptime;
		}
        if($_REQUEST['typeb'] == 'ticket'){
			$Typeb = '工单';
        }elseif($_REQUEST['typeb'] == 'cart'){
			$Typeb = '购买';
		}else{
			$Typeb = '注册';
		}
		return array('pagetitle' => '黑名单','requirelogin' => false,'templatefile' => 'templates/fail', 'vars' => array('stoptime' => $Stoptime,'type' => '手机','value' => $InfoFind->value,'reason' => $InfoFind->reason,'connectaddress' => $vars['connectaddress'],'typeb' => $Typeb));
	}
    if(getenv("HTTP_CLIENT_IP")){ 
        $ip = getenv("HTTP_CLIENT_IP");  
    }elseif(getenv("HTTP_X_FORWARDED_FOR")){ 
        $ip = getenv("HTTP_X_FORWARDED_FOR");  
    }elseif(getenv("REMOTE_ADDR")) {
        $ip = getenv("REMOTE_ADDR");  
    }else{
		exit('无法获取Ip,请稍后重试'); 
	}	
	$InfoFind = \WHMCS\Database\Capsule::table('mod_blacklist')->where('type','ip')->where('value',$ip)->first();
	if($InfoFind){
        if($InfoFind->stoptime == 'permanent'){
			$Stoptime = '永久';
		}else{
			$Stoptime = $InfoFind->stoptime;
		}
        if($_REQUEST['typeb'] == 'ticket'){
			$Typeb = '工单';
        }elseif($_REQUEST['typeb'] == 'cart'){
			$Typeb = '购买';
		}else{
			$Typeb = '注册';
		}
		return array('pagetitle' => '黑名单','requirelogin' => false,'templatefile' => 'templates/fail', 'vars' => array('stoptime' => $Stoptime,'type' => 'IP','value' => $InfoFind->value,'reason' => $InfoFind->reason,'connectaddress' => $vars['connectaddress'],'typeb' => $Typeb));
	}else{
		return array('pagetitle' => '黑名单','requirelogin' => false,'templatefile' => 'templates/success');
	}
}